/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.wahl.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahl.entity.WahlParameter;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class WahlParameterExtendedDAO extends AbstractWahlParameterDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: WahlAndSchluesselNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM WahlParameter obj WHERE obj.wahl = ?1 AND obj.schluessel = ?2<br>
* SQL: <br>
*/
@Override
public WahlParameter findByWahlAndSchluessel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String schluessel) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlParameter.findByWahlAndSchluessel" ,  wahl ,  schluessel  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndSchluessel(): Miss");
        }

        cache.put(key, super.findByWahlAndSchluessel( wahl ,  schluessel  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndSchluessel(): Hit");
      }

      return (WahlParameter) cache.lookup(key);
    }

    return super.findByWahlAndSchluessel( wahl ,  schluessel  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM WahlParameter obj WHERE obj.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<WahlParameter> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlParameter.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<WahlParameter>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}
/**
* Name: WahlterminNotWahlAndSchluesselNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM WahlParameter obj WHERE obj.wahltermin = ?1 AND obj.schluessel = ?2 AND obj.wahl IS NULL<br>
* SQL: <br>
*/
@Override
public WahlParameter findByWahlterminNotWahlAndSchluessel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull java.lang.String schluessel) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlParameter.findByWahlterminNotWahlAndSchluessel" ,  wahltermin ,  schluessel  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminNotWahlAndSchluessel(): Miss");
        }

        cache.put(key, super.findByWahlterminNotWahlAndSchluessel( wahltermin ,  schluessel  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminNotWahlAndSchluessel(): Hit");
      }

      return (WahlParameter) cache.lookup(key);
    }

    return super.findByWahlterminNotWahlAndSchluessel( wahltermin ,  schluessel  );
}
/**
* Name: WahlterminNotWahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM WahlParameter obj WHERE obj.wahltermin = ?1 AND obj.wahl IS NULL<br>
* SQL: <br>
*/
@Override
public java.util.List<WahlParameter> findByWahlterminNotWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlParameter.findByWahlterminNotWahl" ,  wahltermin  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminNotWahl(): Miss");
        }

        cache.put(key, super.findByWahlterminNotWahl( wahltermin  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminNotWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<WahlParameter>) cache.lookup(key));
    }

    return super.findByWahlterminNotWahl( wahltermin  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
